<template>
  <b-container class="my-4">
    <b-row>
      <b-col cols="12" md="8" lg="6" class="mx-auto">
        <b-card no-body class="shadow chat-card spaceship">
          <b-card-header class="text-center chat-header">
            <strong>iGP notification</strong>
            <span class="websocket-indicator"
                  :class="{ 'connected': isWebSocketConnected, 'disconnected': !isWebSocketConnected }"></span>

          </b-card-header>

          <b-card-body class="chat-window">
            <TransitionGroup name="bounce">
              <div
                v-for="(notification, index) in notifications"
                :key="`notification-${notification._id || index}`"
                class="chat-message p-2 my-1 rounded"
                :style="{
                  backgroundColor: getSenderColor(notification.sender),
                }"
              >
                <div class="chat-sender">{{ notification.sender }}</div>
                <div class="message-content">{{ notification.message }}</div>
                <div class="message-time">
                  {{ formatTime(notification.date) }}
                </div>
              </div>
            </TransitionGroup>
          </b-card-body>

          <b-card-footer class="chat-footer">
            <b-form @submit.prevent="sendNotification">
              <b-input-group>
                <b-form-input
                  v-model="notificationMessage"
                  placeholder="Enter a notification message..."
                  required
                ></b-form-input>
                <b-input-group-append>
                  <b-button type="submit" variant="outline-primary"
                    >Send
                  </b-button>
                </b-input-group-append>
              </b-input-group>
            </b-form>
          </b-card-footer>
        </b-card>
      </b-col>
    </b-row>
  </b-container>
</template>

<script>
import { notifications, notify } from '@/provider/provider';
import moment from 'moment';

export default {
  name: 'NotificationSender',
  data() {
    return {
      notificationMessage: '',
      notifications: [],
      ws: null,
      senderColors: {},
      isWebSocketConnected: false,
    };
  },
  mounted() {
    notifications().then((response) => {
      response.data.forEach((notification) => {
        this.notifications.push(notification);
      });
      this.connectToWebSocket();
    });
  },
  methods: {
    async sendNotification() {
      try {
        await notify(this.notificationMessage);
        this.notificationMessage = '';
      } catch (error) {
        console.error('Error sending notification:', error);
      }
    },
    connectToWebSocket() {
      const token = localStorage.getItem('userToken');
      let url = `ws://${process.env.VUE_APP_BACKEND_HOST}:30001/?token=${token}`;
      this.ws = new WebSocket(url);

      this.ws.onopen = () => {
        console.log('WebSocket connection established');
        this.isWebSocketConnected = true;
      };

      this.ws.onmessage = (event) => {
        const notification = JSON.parse(event.data);
        this.notifications.push(notification);
      };

      this.ws.onerror = (error) => {
        this.isWebSocketConnected = false;

        console.error('WebSocket error:', error);
      };

      this.ws.onclose = () => {
        this.isWebSocketConnected = false;

        console.log('WebSocket connection closed');
      };
    },
    getSenderColor(sender) {
      if (!this.senderColors[sender]) {
        const randomColor = `#${Math.floor(Math.random() * 16777215).toString(
          16
        )}`;
        this.senderColors[sender] = this.hexToRGBA(randomColor, 0.2);
      }
      return this.senderColors[sender];
    },

    hexToRGBA(hex, opacity) {
      let r = parseInt(hex.slice(1, 3), 16),
        g = parseInt(hex.slice(3, 5), 16),
        b = parseInt(hex.slice(5, 7), 16);

      return `rgba(${r}, ${g}, ${b}, ${opacity})`;
    },
    formatTime(date) {
      return moment(date).format('HH:mm');
    },
  },
  beforeUnmount() {
    if (this.ws) {
      this.ws.close();
    }
  },
};
</script>

<style>
.bounce-enter-active {
  animation: bounce-in 0.5s;
}

.bounce-leave-active {
  animation: bounce-in 0.5s reverse;
}

@keyframes bounce-in {
  0% {
    transform: scale(0);
    transform: translateX(-100%);
    transform: rotate3d(45, 43, 23, 90deg);
  }
  50% {
    transform: scale(1.1);
  }
  100% {
    transform: scale(1);
    transform: translateX(-0%);
    transform: rotate3d(0, 0, 0, 0deg);
  }
}

.chat-window {
  height: 60vh;
  overflow-y: auto;
}

.chat-message {
  margin-bottom: 10px;
  border-radius: 5px;
  padding: 10px;
}

.chat-sender {
  font-weight: bold;
}

.message-content {
  margin-top: 5px;
}

.message-time {
  font-size: 0.75rem;
  text-align: right;
  margin-top: 5px;
}

.websocket-indicator {
  height: 10px;
  width: 10px;
  border-radius: 50%;
  display: inline-block;
  margin-left: 10px;
}

.connected {
  background-color: green;
}

.disconnected {
  background-color: red;
}
</style>
